|
| 1 | +# 题目描述(中等难度) |
| 2 | + |
| 3 | + |
| 4 | + |
| 5 | +和 [95 题](<https://leetcode.wang/leetCode-95-Unique-Binary-Search-TreesII.html>)一样,只不过这道题不需要输出所有的树,只需要输出所有可能的二分查找树的数量。所以完全按照 95 题思路写,大家可以先到 [95 题](<https://leetcode.wang/leetCode-95-Unique-Binary-Search-TreesII.html>)看一看。 |
| 6 | + |
| 7 | +# 解法一 递归 |
| 8 | + |
| 9 | +下边是 95 题的分析。 |
| 10 | + |
| 11 | +> 我们可以利用一下查找二叉树的性质。左子树的所有值小于根节点,右子树的所有值大于根节点。 |
| 12 | +> |
| 13 | +> 所以如果求 1...n 的所有可能。 |
| 14 | +> |
| 15 | +> 我们只需要把 1 作为根节点,[ ] 空作为左子树,[ 2 ... n ] 的所有可能作为右子树。 |
| 16 | +> |
| 17 | +> 2 作为根节点,[ 1 ] 作为左子树,[ 3...n ] 的所有可能作为右子树。 |
| 18 | +> |
| 19 | +> 3 作为根节点,[ 1 2 ] 的所有可能作为左子树,[ 4 ... n ] 的所有可能作为右子树,然后左子树和右子树两两组合。 |
| 20 | +> |
| 21 | +> 4 作为根节点,[ 1 2 3 ] 的所有可能作为左子树,[ 5 ... n ] 的所有可能作为右子树,然后左子树和右子树两两组合。 |
| 22 | +> |
| 23 | +> ... |
| 24 | +> |
| 25 | +> n 作为根节点,[ 1... n ] 的所有可能作为左子树,[ ] 作为右子树。 |
| 26 | +> |
| 27 | +> 至于,[ 2 ... n ] 的所有可能以及 [ 4 ... n ] 以及其他情况的所有可能,可以利用上边的方法,把每个数字作为根节点,然后把所有可能的左子树和右子树组合起来即可。 |
| 28 | +> |
| 29 | +> 如果只有一个数字,那么所有可能就是一种情况,把该数字作为一棵树。而如果是 [ ],那就返回 null。 |
| 30 | +
|
| 31 | +对于这道题,我们会更简单些,只需要返回树的数量即可。求当前根的数量,只需要左子树的数量乘上右子树。 |
| 32 | + |
| 33 | +```java |
| 34 | +public int numTrees(int n) { |
| 35 | + if (n == 0) { |
| 36 | + return 0; |
| 37 | + } |
| 38 | + return getAns(1, n); |
| 39 | + |
| 40 | +} |
| 41 | +private int getAns(int start, int end) { |
| 42 | + int ans = 0; |
| 43 | + //此时没有数字,只有一个数字,返回 1 |
| 44 | + if (start >= end) { |
| 45 | + return 1; |
| 46 | + } |
| 47 | + //尝试每个数字作为根节点 |
| 48 | + for (int i = start; i <= end; i++) { |
| 49 | + //得到所有可能的左子树 |
| 50 | + int leftTreesNum = getAns(start, i - 1); |
| 51 | + //得到所有可能的右子树 |
| 52 | + int rightTreesNum = getAns(i + 1, end); |
| 53 | + //左子树右子树两两组合 |
| 54 | + ans+=leftTreesNum * rightTreesNum; |
| 55 | + } |
| 56 | + return ans; |
| 57 | +} |
| 58 | +``` |
| 59 | + |
| 60 | +受到[这里](<https://leetcode.com/problems/unique-binary-search-trees/discuss/31696/Simple-Recursion-Java-Solution-with-Explanation>)的启发,我们甚至可以改写的更简单些。因为 95 题要把每颗树返回,所有传的参数是 start 和 end。这里的话,我们只关心数量,所以不需要具体的范围,而是传树的节点的数量即可。 |
| 61 | + |
| 62 | +```java |
| 63 | +public int numTrees(int n) { |
| 64 | + if (n == 0) { |
| 65 | + return 0; |
| 66 | + } |
| 67 | + return getAns(n); |
| 68 | + |
| 69 | +} |
| 70 | + |
| 71 | +private int getAns(int n) { |
| 72 | + int ans = 0; |
| 73 | + //此时没有数字或者只有一个数字,返回 1 |
| 74 | + if (n==0 ||n==1) { |
| 75 | + return 1; |
| 76 | + } |
| 77 | + //尝试每个数字作为根节点 |
| 78 | + for (int i = 1; i <= n; i++) { |
| 79 | + //得到所有可能的左子树 |
| 80 | + // i - 1 代表左子树节点的数量 |
| 81 | + int leftTreesNum = getAns(i-1); |
| 82 | + //得到所有可能的右子树 |
| 83 | + //n - i 代表左子树节点的数量 |
| 84 | + int rightTreesNum = getAns(n-i); |
| 85 | + //左子树右子树两两组合 |
| 86 | + ans+=leftTreesNum * rightTreesNum; |
| 87 | + } |
| 88 | + return ans; |
| 89 | +} |
| 90 | +``` |
| 91 | + |
| 92 | +然后,由于递归的分叉,所以会导致很多重复解的计算,所以使用 memoization 技术,把递归过程中求出的解保存起来,第二次需要的时候直接拿即可。 |
| 93 | + |
| 94 | +```java |
| 95 | +public int numTrees(int n) { |
| 96 | + if (n == 0) { |
| 97 | + return 0; |
| 98 | + } |
| 99 | + HashMap<Integer,Integer> memoization = new HashMap<>(); |
| 100 | + return getAns(n,memoization); |
| 101 | + |
| 102 | +} |
| 103 | + |
| 104 | +private int getAns(int n, HashMap<Integer,Integer> memoization) { |
| 105 | + if(memoization.containsKey(n)){ |
| 106 | + return memoization.get(n); |
| 107 | + } |
| 108 | + int ans = 0; |
| 109 | + //此时没有数字,只有一个数字,返回 1 |
| 110 | + if (n==0 ||n==1) { |
| 111 | + return 1; |
| 112 | + } |
| 113 | + //尝试每个数字作为根节点 |
| 114 | + for (int i = 1; i <= n; i++) { |
| 115 | + //得到所有可能的左子树 |
| 116 | + int leftTreesNum = getAns(i-1,memoization); |
| 117 | + //得到所有可能的右子树 |
| 118 | + int rightTreesNum = getAns(n-i,memoization); |
| 119 | + //左子树右子树两两组合 |
| 120 | + ans+=leftTreesNum * rightTreesNum; |
| 121 | + } |
| 122 | + memoization.put(n, ans); |
| 123 | + return ans; |
| 124 | +} |
| 125 | +``` |
| 126 | + |
| 127 | +# 解法二 动态规划 |
| 128 | + |
| 129 | +直接利用[95题](<https://leetcode.wang/leetCode-95-Unique-Binary-Search-TreesII.html>)解法三的思路,讲解比较长就不贴过来了,可以过去看一下。 |
| 130 | + |
| 131 | +或者直接从这里的解法一的思路考虑,因为递归是从顶层往下走,压栈压栈压栈,到了长度是 0 或者是 1 就出栈出栈出栈。我们可以利用动态规划的思想,直接从底部往上走。求出长度是 0,长度是 1,长度是 2....长度是 n 的解。用一个数组 dp 把这些结果全部保存起来。 |
| 132 | + |
| 133 | +```java |
| 134 | +public int numTrees(int n) { |
| 135 | + int[] dp = new int[n + 1]; |
| 136 | + dp[0] = 1; |
| 137 | + if (n == 0) { |
| 138 | + return 0; |
| 139 | + } |
| 140 | + // 长度为 1 到 n |
| 141 | + for (int len = 1; len <= n; len++) { |
| 142 | + // 将不同的数字作为根节点,只需要考虑到 len |
| 143 | + for (int root = 1; root <= len; root++) { |
| 144 | + int left = root - 1; // 左子树的长度 |
| 145 | + int right = len - root; // 右子树的长度 |
| 146 | + dp[len] += dp[left] * dp[right]; |
| 147 | + } |
| 148 | + } |
| 149 | + return dp[n]; |
| 150 | +} |
| 151 | +``` |
| 152 | + |
| 153 | +参考[这里](<https://leetcode.com/problems/unique-binary-search-trees/discuss/31815/A-0-ms-c%2B%2B-solution-with-my-explanation>)还有优化的空间。 |
| 154 | + |
| 155 | +利用对称性,可以使得循环减少一些。 |
| 156 | + |
| 157 | +* n 是偶数的时候 |
| 158 | + 1 2 | 3 4 ,for 循环中我们以每个数字为根求出每个的解。我们其实可以只求一半,根据对称性我们可以知道 1 和 4,2 和 3 求出的解分别是相等的。 |
| 159 | + |
| 160 | +* n 是奇数的时候 |
| 161 | + |
| 162 | + 1 2 | 3 | 4 5,和偶数同理,只求一半,此外最中间的 3 的解也要加上。 |
| 163 | + |
| 164 | +```java |
| 165 | +public int numTrees6(int n) { |
| 166 | + if (n == 0) { |
| 167 | + return 0; |
| 168 | + } |
| 169 | + int[] dp = new int[n + 1]; |
| 170 | + dp[0] = 1; |
| 171 | + dp[1] = 1; |
| 172 | + // 长度为 1 到 n |
| 173 | + for (int len = 2; len <= n; len++) { |
| 174 | + // 将不同的数字作为根节点,只需要考虑到 len |
| 175 | + for (int root = 1; root <= len / 2; root++) { |
| 176 | + int left = root - 1; // 左子树的长度 |
| 177 | + int right = len - root; // 右子树的长度 |
| 178 | + dp[len] += dp[left] * dp[right]; |
| 179 | + } |
| 180 | + dp[len] *= 2;// 利用对称性乘 2 |
| 181 | + // 考虑奇数的情况 |
| 182 | + if ((len & 1) == 1) { |
| 183 | + int root = (len >> 1) + 1; |
| 184 | + int left = root - 1; // 左子树的长度 |
| 185 | + int right = len - root; // 右子树的长度 |
| 186 | + dp[len] += dp[left] * dp[right]; |
| 187 | + } |
| 188 | + } |
| 189 | + return dp[n]; |
| 190 | +} |
| 191 | +``` |
| 192 | + |
| 193 | +# 解法三 公式法 |
| 194 | + |
| 195 | +参考[这里](<https://leetcode.com/problems/unique-binary-search-trees/discuss/31671/A-very-simple-and-straight-ans-based-on-MathCatalan-Number-O(N)-timesO(1)space>)。其实利用的是卡塔兰数列,这是第二次遇到了,之前是第 [22 题](<https://leetcode.wang/leetCode-22-Generate-Parentheses.html>) ,生成合法的括号序列。 |
| 196 | + |
| 197 | +这道题,为什么和卡塔兰数列联系起来呢? |
| 198 | + |
| 199 | +看一下卡塔兰树数列的定义: |
| 200 | + |
| 201 | +> 令h ( 0 ) = 1,catalan 数满足递推式: |
| 202 | +> |
| 203 | +> **h ( n ) = h ( 0 ) \* h ( n - 1 ) + h ( 1 ) \* h ( n - 2 ) + ... + h ( n - 1 ) \* h ( 0 ) ( n >=1 )** |
| 204 | +> |
| 205 | +> 例如:h ( 2 ) = h ( 0 ) \* h ( 1 ) + h ( 1 ) \* h ( 0 ) = 1 \* 1 + 1 * 1 = 2 |
| 206 | +> |
| 207 | +> h ( 3 ) = h ( 0 ) \* h ( 2 ) + h ( 1 ) \* h ( 1 ) + h ( 2 ) \* h ( 0 ) = 1 \* 2 + 1 \* 1 + 2 \* 1 = 5 |
| 208 | +
|
| 209 | +再看看解法二的算法 |
| 210 | + |
| 211 | +```java |
| 212 | +public int numTrees(int n) { |
| 213 | + int[] dp = new int[n + 1]; |
| 214 | + dp[0] = 1; |
| 215 | + if (n == 0) { |
| 216 | + return 0; |
| 217 | + } |
| 218 | + // 长度为 1 到 n |
| 219 | + for (int len = 1; len <= n; len++) { |
| 220 | + // 将不同的数字作为根节点,只需要考虑到 len |
| 221 | + for (int root = 1; root <= len; root++) { |
| 222 | + int left = root - 1; // 左子树的长度 |
| 223 | + int right = len - root; // 右子树的长度 |
| 224 | + dp[len] += dp[left] * dp[right]; |
| 225 | + } |
| 226 | + } |
| 227 | + return dp[n]; |
| 228 | +} |
| 229 | +``` |
| 230 | + |
| 231 | +完美符合,而卡塔兰数有一个通项公式。 |
| 232 | + |
| 233 | + |
| 234 | + |
| 235 | + |
| 236 | + |
| 237 | +注:$$\binom{2n}{n}$$ 代表 $$C^n_{2n}$$ |
| 238 | + |
| 239 | +化简一下上边的公式 |
| 240 | + |
| 241 | +$$C_n = (2n)!/(n+1)!n! = (2n)*(2n-1)*...*(n+1)/(n+1)!$$ |
| 242 | + |
| 243 | +所以用一个循环即可。 |
| 244 | + |
| 245 | +```java |
| 246 | +int numTrees(int n) { |
| 247 | + long ans = 1, i; |
| 248 | + for (i = 1; i <= n; i++) |
| 249 | + ans = ans * (i + n) / i; |
| 250 | + return (int) (ans / i); |
| 251 | +} |
| 252 | + |
| 253 | +``` |
| 254 | + |
| 255 | +# 总 |
| 256 | + |
| 257 | +上道题会了以后,这道题很好写。解法二中利用对称的优化,解法三的公式太强了。 |
0 commit comments